\documentclass[xcolor=svgnames]{beamer}
\usetheme{Stockton}

\usepackage{epsfig} %for figures
\usepackage{xcolor} %for color
\usepackage[utf8]{inputenc}
\usepackage{multicol}
\usepackage{listings}
\usepackage{textcomp}

%latex definitions:
\def\d{{\rm d}}
\def\half{{\textstyle{1\over2}}}



\title[LFortran\hspace{14em}\insertframenumber/
\inserttotalframenumber]{LFortran: Interactive LLVM-based Fortran Compiler for Modern Architectures}


\author[Čertík, Maan, Pandey, Curcic, Brady, Jibben, Carlson et al.]{%
Ondřej Čertík\inst{1},
Nikhil Maan\inst{2},
Ankit Pandey\inst{3},
Milan Curcic\inst{4},
Peter Brady\inst{1},
Zach Jibben\inst{1},
Neil Carlson\inst{1},
Rohit Goswami\inst{5,6},
Amir Shahmoradi\inst{7},
Arjen Markus\inst{8}%
}

\pgfdeclareimage[height=1.5cm]{mylogo}{images/lanl_logo}
\institute{%
Los Alamos National Laboratory\inst{1};
Amity University, India\inst{2};
Grinnell College\inst{3};
University of Miami\inst{4};
University of Iceland\inst{5};
IIT Kanpur\inst{6};
University of Texas Arlington\inst{7};
Deltares, The Netherlands\inst{8};\\
\vskip0.3cm \pgfuseimage{mylogo}}

\date{July 2, 2020}

\begin{document}

\begin{frame}
\maketitle
\end{frame}

\begin{frame}{Outline}
\begin{itemize}
    \item Motivation
    \item Demo
    \item Architecture
    \item Current Status
    \item Future Plans
    \item Conclusions
\end{itemize}
\end{frame}

\begin{frame}{Motivation}
Everything one would expect from modern Fortran:
\begin{itemize}
    \item Cross platform compilation to binaries
    \item Interactivity (like Python)
    \item Nice error messages and warnings
    \item Automatic interoperability with other languages
    \item Automatic formatting / language server (VSCode)
    \item Run well on modern architectures (GPU)
    \item Clean design, usable as a library
    \item Static analysis
    \item ...
\end{itemize}
As facilitated by a \textbf{modern compiler}!!
\end{frame}

\begin{frame}
\fontsize{24pt}{15}\selectfont
\begin{center}
    {\bf Demo}
\end{center}
{\fontsize{12pt}{10}\selectfont Webpage: \url{https://lfortran.org}}
\end{frame}

\begin{frame}{Architecture}
\begin{center}
\includegraphics[width=\textwidth]{images/arch.pdf}
\end{center}
\vskip0.3in
AST: Abstract Syntax Tree\\
ASR: Abstract Semantic Representation\\
LLVM: modular and reusable compiler and toolchain technologies
\end{frame}


\begin{frame}{Architecture II}
\begin{itemize}
    \item AST and ASR are standalone independent representations
    \item User tools can target ASR or AST (easy to produce
        semantically correct Fortran code)
    \item ASR allows manipulating Fortran code similar to SymPy
    \item ASR allows rewriting / optimizing of the code (inlining, loop
        optimizations, ...) and showing the end result to the user as Fortran
        code
    \item One can also examine the LLVM code (although less readable than
        Fortran).
    \item Will make the compiler more transparent and helpful to the user
\end{itemize}
\end{frame}

\begin{frame}{Current Status}
Prototype:
\begin{itemize}
    \item Prototype in Python, works interactively on all platforms (Linux,
        macOS, Windows), can compile and run simple programs
    \item Proof of concept validating our ideas
\end{itemize}
Production:
\begin{itemize}
    \item Production version is in C++, close to be usable both
        interactively and to compile simple programs
    \item Very fast compilation (building on my experience with SymPy and SymEngine)
    \item Working on LLVM and C++ backends
\end{itemize}
\end{frame}

\begin{frame}{Future Plans}
Near future
\begin{itemize}
    \item Release the first production version to get users (weeks)
    \item Parse all Fortran 2018 syntax to AST (months)
    \item AST to ASR for all of Fortran
    \item Usable LLVM and C++ backends
\end{itemize}
Down the road:
\begin{itemize}
    \item All the other items from the Motivation
\end{itemize}
\end{frame}



\begin{frame}
\fontsize{24pt}{15}\selectfont
\begin{center}
    {\bf End}
\end{center}
\end{frame}


\end{document}
